/*******************************************************************************
 * Quick access to the Components object.
 ******************************************************************************/
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;
/*******************************************************************************
 * Component definitions.
 ******************************************************************************/
const VTI_CLASSNAME = "Netscape Vote Item";
const VTI_CLASSID = Components.ID("{3b462c2e-38e3-1e43-8830-98cd7e4cc8f7}");
const VTI_CONTRACTID = "@netscape.com/vote/item;1";

const VTS_CLASSNAME = "Netscape Vote Service";
const VTS_CLASSID = Components.ID("{fde7ddab-7a4b-f744-bc3b-00cfc2e4e79a}");
const VTS_CONTRACTID = "@netscape.com/vote/service;1";
/*******************************************************************************
 * Contract IDs.
 ******************************************************************************/
const CAT_CONTRACTID = "@mozilla.org/categorymanager;1";
const OB_CONTRACTID = "@mozilla.org/observer-service;1";
const PREF_CONTRACTID = "@mozilla.org/preferences-service;1";
const TIMER_CONTRACTID = "@mozilla.org/timer;1";
const REQUEST_CONTRACTID = "@mozilla.org/xmlextras/xmlhttprequest;1";
const MEDIATOR_CONTRACTID = "@mozilla.org/appshell/window-mediator;1";
const WATCHER_CONTRACTID = "@mozilla.org/embedcomp/window-watcher;1";
const BUNDLE_CONTRACTID = "@mozilla.org/intl/stringbundle;1";
/*******************************************************************************
 * Observer topics
 ******************************************************************************/
const TOPIC_DEFAULT = "netscape-vote";
const TOPIC_SHUTDOWN_APP = "quit-application";
const TOPIC_SHUTDOWN_XPCOM = "xpcom-shutdown";
const TOPIC_STARTUP_APP = "app-startup";
const TOPIC_STARTUP_UI = "final-ui-startup";
const TOPIC_PREF = "nsPref:changed";
const TOPIC_TIMER = "timer-callback";
/*******************************************************************************
 * Checker values
 ******************************************************************************/
const CHECKER_URL = "endpoint.api";
/*******************************************************************************
 * Update Manager values
 ******************************************************************************/
const UPDATE_BUNDLE = "chrome://browser/locale/netscape-vote/vote.properties";
const UPDATE_VOTE = "endpoint.vote";
const UPDATE_SINK = "endpoint.sink";
const UPDATE_TITLE = "vote.module.voted.title";
const UPDATE_MESSAGE = "vote.module.voted.message";
/*******************************************************************************
 * Service values
 ******************************************************************************/
const SERVICE_BRANCH = "extensions.netscape.vote.";
const SERVICE_DISABLED = "disabled";
const SERVICE_BLACKLIST = "^https?://[^/]*((anchors|design|autos|books|humor|careers|celebrities|diy|donoevil|family|travel|gay|health|personals|men|money|movies|music|news|pets|politics|videos|realestate|religion|science|shopping|sports|tech|tv|videogames|women|www)\.netscape\.com|\.?hotmail\.com|mail\.google\.com)/";
const SERVICE_PERMALINK = "www\.netscape\.com/story/[0-9]{4}/[0-9]{2}/[0-9]{2}/.*";
const SERVICE_PERMAFIX = "www\..netscape\.com/story/[0-9]{4}/[0-9]{2}/[0-9]{2}/.*/";
const SERVICE_SCAN = "scan";
const SERVICE_UPDATE = "update";
/*******************************************************************************
 * Helper object to encode and decode base64 since we cannot use btoa/atop.
 ******************************************************************************/
var Base64 = {

  // private property
  _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
   
  // public method for encoding
  encode: function Base64_encode(input) {
    var output = "";
    var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
    var i = 0;

    input = this._utf8_encode(input);
    while (i<input.length) {

      chr1 = input.charCodeAt(i++);
      chr2 = input.charCodeAt(i++);
      chr3 = input.charCodeAt(i++);

      enc1 = chr1 >> 2;
      enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
      enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
      enc4 = chr3 & 63;

      if (isNaN(chr2))
        enc3 = enc4 = 64;
      else if (isNaN(chr3))
        enc4 = 64;

      output = output +
               this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
               this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

    }

    return output;
  },

  // public method for decoding
  decode: function Base64_decode(input) {
    var output = "";
    var chr1, chr2, chr3;
    var enc1, enc2, enc3, enc4;
    var i = 0;

    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
    while (i<input.length) {

      enc1 = this._keyStr.indexOf(input.charAt(i++));
      enc2 = this._keyStr.indexOf(input.charAt(i++));
      enc3 = this._keyStr.indexOf(input.charAt(i++));
      enc4 = this._keyStr.indexOf(input.charAt(i++));

      chr1 = (enc1 << 2) | (enc2 >> 4);
      chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
      chr3 = ((enc3 & 3) << 6) | enc4;

      output = output + String.fromCharCode(chr1);
      if (enc3 != 64)
        output = output + String.fromCharCode(chr2);  
      if (enc4 != 64)
        output = output + String.fromCharCode(chr3);
    }
    
    output = this._utf8_decode(output);
    return output;
  },

  // private method for UTF-8 encoding
  _utf8_encode: function Base64__utf8_encode(string) {
    string = string.replace(/\r\n/g,"\n");
    var utftext = "";

    for (var n=0; n<string.length; n++) {
      var c = string.charCodeAt(n);
      
      if (c<128)
        utftext += String.fromCharCode(c);
      else if((c>127) && (c<2048)) {
        utftext += String.fromCharCode((c >> 6) | 192);
        utftext += String.fromCharCode((c & 63) | 128);
      } else {
        utftext += String.fromCharCode((c >> 12) | 224);
        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
        utftext += String.fromCharCode((c & 63) | 128);
      }
    }

    return utftext;
  },

  // private method for UTF-8 decoding
  _utf8_decode: function Base64__utf8_decode(utftext) {
    var string = "";
    var i = 0;
    var c = c1 = c2 = 0;

    while (i<utftext.length) {
      c = utftext.charCodeAt(i);

      if (c<128) {
        string += String.fromCharCode(c);
        i++;
      } else if((c>191) && (c<224)) {
        c2 = utftext.charCodeAt(i+1);
        string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
        i += 2;
      } else {
        c2 = utftext.charCodeAt(i+1);
        c3 = utftext.charCodeAt(i+2);
        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
        i += 3;
      }

    }

    return string;
  }
}; 
/******************************************************************************
 * Get the main application window.  Use this if the type of window does matter.
 * 
 * @return  A window object used for modality.
 *****************************************************************************/
function getMainWindow()
{
  //get the app window
  var mediator = Cc[MEDIATOR_CONTRACTID].getService(Ci.nsIWindowMediator);
  var main = mediator.getMostRecentWindow("navigator:browser");
  if (main)
    return main;
                       
  //open a new window  
  var watcher = Cc[WATCHER_CONTRACTID].getService(Ci.nsIWindowWatcher);                 
  main = watcher.openWindow(null, "chrome://browser/content/browser.xul", 
                            "_blank", "chrome,all,dialog=no", "about:blank");  
  return main;
}
/******************************************************************************
 * Get a new prompter.
 *
 * @param   The parent window for the prompter can be null.
 *
 * @return  A new prompter. 
 *****************************************************************************/
function getPrompter(aParent)
{
  //get the watcher service
  var watcher = Cc["@mozilla.org/embedcomp/window-watcher;1"].
                getService(Ci.nsIWindowWatcher);
                
  //return a prompter
  return watcher.getNewPrompter(aParent);
}
/*******************************************************************************
 * Object used to check with the story status api for vote data.
 *
 * @param     service        The vote service.
 ******************************************************************************/
function VoteChecker(service) {
  this.voteService = service;
}
VoteChecker.prototype = {

  _voteService: null,
  get voteService() { return this._voteService; },
  set voteService(val) { this._voteService = val; },
  
  _requests: null,
  get requests() { return this._requests; },
  set requests(val) { this._requests = val; },
    
  // nsISupports
  QueryInterface: function vtc_QI(iid) {
    if (iid.equals(Ci.nsIObserver) ||
        iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE; 
  },

  load: function vtc_load() {
    this.requests = {};
  },
  
  unload: function vtc_unload() {
    
    // stop any requests
    var requests = this.requests;
    for (var URL in requests)
      requests[URL].abort();
    
    // remove variables
    this.requests = null;  
    this.voteService = null;
  },

  addURL: function vtc_addURL(URL) {
    if (this.requests.hasOwnProperty(URL))
      return;
    this.requestUpdate(URL);    
  },
  
  requestUpdate: function vtc_requestUpdate(URL) {
           
    // create an XML HTTP request  
    var self = this;
    var request = Cc[REQUEST_CONTRACTID].createInstance(Ci.nsIXMLHttpRequest);
    var api = this.voteService._branch.getCharPref(CHECKER_URL) 
    api += Base64.encode(URL);
    request.open("GET", api, true);
    request.overrideMimeType("text/xml");
    request.setRequestHeader("X-Netscape", "Navigator", false);        
    request.onerror = function(event) { self.onError(event, URL);    };
    request.onload = function(event) { self.onLoad(event, URL);     };
   
    // send the request
    request.send(null);  
    this.requests[URL] = request;    
  },
  
  onLoad: function vtc_onLoad(event, URL) {
  
    // get the vote item from the xml
    var request = this.requests[URL];
    var item = this.createItem(request.responseXML);
    
    // remove the request
    delete this.requests[URL]; 
    
    // cache the data and notify the front-end
    this.voteService._data[URL] = item;
    this.voteService._notify(item, SERVICE_UPDATE); 
  },
  
  onError: function vtc_onError(event, URL) {
    delete this.requests[URL];     
  },
  
  createItem: function vtc_createItem(xml) {
  
    // parse the vote data
    var data = {  URL: "",
                  submitted: false,
                  voted: false,
                  voteCount: 0,
                  sinkCount: 0,
                  commentCount: 0,
                  permaLink: ""
                };
    data.URL = xml.getElementsByTagName("story")[0].getElementsByTagName("url")[0].firstChild.nodeValue;
    data.submitted = (xml.getElementsByTagName("story")[0].getAttribute("submitted") == "true") ? true : false;
    data.voted = (xml.getElementsByTagName("story")[0].getAttribute("votedOn") == "true") ? true : false;
    
    if (data.submitted){
      data.voteCount = parseInt(xml.getElementsByTagName("votecount")[0].firstChild.nodeValue);
      data.sinkCount = parseInt(xml.getElementsByTagName("sinkcount")[0].firstChild.nodeValue);
      data.commentCount = parseInt(xml.getElementsByTagName("commentcount")[0].firstChild.nodeValue);
      data.permaLink = xml.getElementsByTagName("link")[0].firstChild.nodeValue;
    }
    
    // create a vote item and return it
    var item = Cc[VTI_CONTRACTID].createInstance(Ci.nsIVoteItem);
    item.init(data.URL, data.submitted, data.voted, data.voteCount, 
              data.sinkCount, data.commentCount, data.permaLink);
    return item;                         
  }  
};
/*******************************************************************************
 * Object used to update the vote status.
 *
 * @param     service        The vote service.
 ******************************************************************************/
function UpdateManager(service) {
  this.voteService = service;
}
UpdateManager.prototype = {
  
  _voteService: null,
  get voteService() { return this._voteService; },
  set voteService(val) { this._voteService = val; },
  
  _requests: null,
  get requests() { return this._requests; },
  set requests(val) { this._requests = val; },
    
  // nsISupports
  QueryInterface: function vtc_QI(iid) {
    if (iid.equals(Ci.nsIObserver) ||
        iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE; 
  },

  load: function upm_load() {
    this.requests = {};
  },
  
  unload: function upm_unload() {
    
    // stop any requests
    var requests = this.requests;
    for (var URL in requests)
      requests[URL].abort();

    // remove variables
    this.requests = null;  
    this.voteService = null;
  },
  
  addUpdate: function upm_addUpdate(item, type) {
    if (this.requests.hasOwnProperty(item.URL))
      return;
    this.requestUpdate(item, type);    
  },
  
  requestUpdate: function upm_requestUpdate(item, type) {
           
    // create an XML HTTP request  
    var self = this;
    var URL = item.URL;
    var request = Cc[REQUEST_CONTRACTID].createInstance(Ci.nsIXMLHttpRequest);
    var api = null;
    if (type == Ci.nsIVoteService.TYPE_VOTE)
      api = this.voteService._branch.getCharPref(UPDATE_VOTE);
    else
      api = this.voteService._branch.getCharPref(UPDATE_SINK); 
    api += Base64.encode(URL);
    request.open("GET", api, true);
    request.overrideMimeType("text/xml");
    request.setRequestHeader("X-Netscape", "Navigator", false);        
    request.onerror = function(event) { self.onError(event, item);    };
    request.onload = function(event) { self.onLoad(event, item);     };
   
    // send the request
    request.send(null);  
    this.requests[URL] = request;    
  },
  
  onLoad: function upm_onLoad(event, item) {
  
    // get the vote item from the xml
    var request = this.requests[item.URL];
    this.updateItem(request.responseXML, item);
    
    // remove the request
    delete this.requests[item.URL]; 
  },
  
  onError: function upm_onError(event, item) {
    delete this.requests[item.URL];     
  },
  
  updateItem: function upm_updateItem(xml, item) {
  
    // get the vote root
    var voteRoot = xml.getElementsByTagName("vote")[0];
    if (!voteRoot)
      return;       
    
    // check for loggedIn
    var loggedIn = voteRoot.getAttribute("loggedIn");
    if (loggedIn != "1") {

      // redirect to sign in
      var redir = voteRoot.getElementsByTagName("link")[0].childNodes[0].nodeValue;
      var win = getMainWindow();
      var browser = win.document.getElementById("content"); 
      browser.loadURI(redir);
      win.content.focus();
      return;
    }
    
    // parse the vote data
    var data = {  URL: item.URL,
                  submitted: item.submitted,
                  voted: true,
                  voteCount: item.voteCount,
                  sinkCount: item.sinkCount,
                  commentCount: item.commentCount,
                  permaLink: item.permaLink
                };                  
    data.voteCount = parseInt(voteRoot.getElementsByTagName("votecount")[0].firstChild.nodeValue);
    data.sinkCount = parseInt(voteRoot.getElementsByTagName("sinkcount")[0].firstChild.nodeValue);    
    item.init(data.URL, data.submitted, data.voted, data.voteCount, 
              data.sinkCount, data.commentCount, data.permaLink);
      
    // cache the data and notify the front-end
    this.voteService._data[data.URL] = item;
    this.voteService._notify(item, SERVICE_UPDATE); 
                  
    // show dialog if already voted
    var showAlert = (voteRoot.getAttribute("counted") == "0") ? true : false;
    if (showAlert)
      this.showPrompt();                      
  },
  
  showPrompt: function upm_showPrompt() {
  
    // setup string bundle
    var sbService = Cc[BUNDLE_CONTRACTID].getService(Ci.nsIStringBundleService);
    bundle = sbService.createBundle(UPDATE_BUNDLE);     
    
    // get strings
    var title = bundle.GetStringFromName(UPDATE_TITLE);
    var message = bundle.GetStringFromName(UPDATE_MESSAGE);
    
    // show prompt
    var prompter = getPrompter(getMainWindow());
        prompter.alert(title, message);    
  }   
};
/*******************************************************************************
 * Interface used to describe a vote item.  This interface is used to 
 * represent meta data describing a story's vote status on netscape.com
 * 
 * @version   1.0
 ******************************************************************************/
function VoteItem() {}
VoteItem.prototype = {
  _URL: null,
  _submitted: null,
  _voted: null,
  _voteCount: null,
  _sinkCount: null,
  _commentCount: null,
  _permaLink: null,
  
  // nsISupports
  QueryInterface: function vti_QI(iid) {
    if (iid.equals(Ci.nsIVoteItem) ||
        iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE; 
  },

  // nsIVoteItem
  get URL() { return this._URL; },
  get submitted() { return this._submitted; },
  get voted() { return this._voted; },
  get voteCount() { return this._voteCount; },
  get sinkCount() { return this._sinkCount; },
  get commentCount() { return this._commentCount; },
  get permaLink() { return this._permaLink; },
  
  init: function vti_init(URL, submitted, voted, voteCount, 
                          sinkCount, commentCount, permaLink) {

    this._URL = URL;
    this._submitted = submitted;
    this._voted = voted;
    this._voteCount = voteCount;
    this._sinkCount = sinkCount;
    this._commentCount = commentCount;
    this._permaLink = permaLink;
  },

  clone: function vti_clone() {
    var rv = Cc[VTI_CONTRACTID].createInstance(Ci.nsIVoteItem);

    rv.init(this._URL, this._submitted, this._voted, this._voteCount, 
            this._sinkCount, this._commentCount, this._permaLink);
    
    return rv;
  }     
};
/*******************************************************************************
 * The main vote interface.  This interface takes care of updating the 
 * vote status data.  It notifies the front-end
 * when updates take place.
 * 
 * @version   1.0
 ******************************************************************************/
function VoteService() {}
VoteService.prototype = {
  _obService: null,
  _branch: null,
  _disabled: null,
  _blackList: null,
  _permaLink: null, 
  _permaFix: null,
  _checker: null, 
  _updater: null, 
  _data: null,
          
  // nsISupports
  QueryInterface: function vts_QI(iid) {
    if (iid.equals(Ci.nsIVoteService) ||
        iid.equals(Ci.nsIObserver) ||
        iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE; 
  },
  
  // nsIObserver
  observe: function vts_observe(subject, topic, data) {
    switch (topic) {
          
    case TOPIC_STARTUP_APP:
      this._load();
      break;
    
    case TOPIC_STARTUP_UI:
      this._loadDelayed();
      break;
    
    case TOPIC_SHUTDOWN_APP:
      this._unload();
      break;
              
    case TOPIC_SHUTDOWN_XPCOM:
      this._unloadDelayed();
      break;
    
    case TOPIC_PREF:
      this._disabled = this._branch.getBoolPref(SERVICE_DISABLED);
      break;
      
    default:
      return;
    }
  },
  
  // nsIVoteService
  get disabled() { return this._disabled; },
  
  checkURL: function vts_checkURL(URL) {
    
    // return null if disabled
    if (this.disabled)
      return null;
      
    // return null if not an http or ftp site
    if (!URL || (URL.indexOf("http") != 0 && URL.indexOf("ftp") != 0))
      return null;
    
    // match on the domain blacklist
	if (URL.match(this._blackList)) {
  
      // match on permalink
      if (URL.match(this._permaLink)) {
        
        // create a vote item and notify the front-end we need a document scan  
        var item = Cc[VTI_CONTRACTID].createInstance(Ci.nsIVoteItem);
        item.init("", true, false, 0, 0, 0, URL);
        this._notify(item, SERVICE_SCAN);
        return null;
      }
      
      // blacklist and not a permalink
      return null;
    }
    
    // return the stored url
    if (this._data.hasOwnProperty(URL))
      return this._data[URL];
  
    // return null and submit a check request
    this._checker.addURL(URL);
    return null;
  },
  
  scanDocument: function vts_scanDocument(doc) {
    
    // do nothing if disabled
    if (this.disabled)
      return;
      
    // loop through the link elements        
    var links = doc.getElementsByTagName("link");            
    for (var i=0; i<links.length; i++) {
    
      // release attribute not equal to bookmark
      var link = links[i];
      if (link.getAttribute("rel") != "bookmark")
        continue;
        
      // title attribute not equal to Source
      if (link.getAttribute("title") != "Source")
        continue;
          

      // store the link data              
      var data = {  URL: "",
                    submitted: false,
                    voted: false,
                    voteCount: 0,
                    sinkCount: 0,
                    commentCount: 0,
                    permaLink: ""
                  };    
      data.submitted = true;
      data.URL = link.getAttribute("href");
      data.permaLink = doc.location.href;
      
      // fixup the permalink
      var res = data.permaLink.match(this._permaFix);
      if (res)
        data.permaLink = res[0];
                      
      // find the vote and comment values.
      var metas = doc.getElementsByTagName("meta");            
      for (var x=0; x<metas.length; x++) {
      
        var meta = metas[x];
        var name = meta.getAttribute("name");
        var content = meta.getAttribute("content");
        switch  (name) {
        
        case "votes":
          data.voteCount = parseInt(content);
          break;
          
        case "sinks":
          data.sinkCount = parseInt(content);
          break;
          
        case "comments":
          data.commentCount = parseInt(content);
          break;
          
        default:
          break;
        }
      }
      
      // store the value
      var item = Cc[VTI_CONTRACTID].createInstance(Ci.nsIVoteItem);
      item.init(data.URL, data.submitted, data.voted, data.voteCount, 
                data.sinkCount, data.commentCount, data.permaLink);
      this._data[data.URL] = item;
      break;
    }  
  },
  
  submitUpdate: function vts_submitUpdate(item, type) {
    this._updater.addUpdate(item.clone(), type);
  },
        
  _load: function vts__load() {
  
    // add observers
    this._obService = Cc[OB_CONTRACTID].getService(Ci.nsIObserverService);
    this._obService.addObserver(this, TOPIC_STARTUP_UI, false);
    this._obService.addObserver(this, TOPIC_SHUTDOWN_APP, false);
    this._obService.addObserver(this, TOPIC_SHUTDOWN_XPCOM, false);
    this._branch = Cc[PREF_CONTRACTID].getService(Ci.nsIPrefService).
                   getBranch(SERVICE_BRANCH);
    this._branch.QueryInterface(Ci.nsIPrefBranch2).addObserver("", this, false);
        
    // setup variables
    this._disabled = this._branch.getBoolPref(SERVICE_DISABLED);    
    this._blackList = new RegExp(SERVICE_BLACKLIST, "i");
    this._permaLink = new RegExp(SERVICE_PERMALINK, "i");
    this._permaFix = new RegExp(SERVICE_PERMAFIX, "i"); 
    this._checker = new VoteChecker(this);
    this._updater = new UpdateManager(this);
    this._data = {};       
  },
  
  _loadDelayed: function vts__loadDelayed() {
    this._checker.load();
    this._updater.load();
  },
  
  _unload: function vts__unload() {
    this._checker.unload();
    this._updater.unload();
  },
  
  _unloadDelayed: function vts__unloadDelayed() {
         
    // remove observers
    this._obService.removeObserver(this, TOPIC_STARTUP_UI);
    this._obService.removeObserver(this, TOPIC_SHUTDOWN_APP);    
    this._obService.removeObserver(this, TOPIC_SHUTDOWN_XPCOM);
    this._branch.QueryInterface(Ci.nsIPrefBranch2).removeObserver("", this);
        
    // remove variables
    this._obService = null;
    this._branch = null;
    this._disabled = null;
    this._blackList = null;
    this._permaLink = null;
    this._permaFix = null;
    this._checker = null;  
    this._updater = null;  
    this._data = null;
  },
  
  _notify: function vts__notifyObservers(subject, data) {
    try {
      this._obService.notifyObservers(subject, TOPIC_DEFAULT, data);
    } catch(e) {
      Components.utils.reportError(e);
    }
  }     
};
/*******************************************************************************
 * Generic object used as a factory based on a passed in constructor.
 ******************************************************************************/
function GenericFactory(ctor) {
  this._ctor = ctor;
}  
GenericFactory.prototype = {
  _ctor: null,
  
  // nsISupports
  QueryInterface: function gf_QI(iid) {
    if (iid.equals(Ci.nsIFactory) ||
        iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE; 
  },
  
  // nsIFactory
  createInstance: function gf_createInstance(outer, iid) {
    if (outer !== null)
      throw Cr.NS_ERROR_NO_AGGREGATION;
    return (new this._ctor()).QueryInterface(iid);
  },

  lockFactory: function gf_lockFactory(loc) {
    throw Cr.NS_ERROR_NOT_IMPLEMENTED;
  }
};
/*******************************************************************************
 * Object implementing the nsIModule interface.  This is used to retrieve 
 * the different components and services the module implements.
 ******************************************************************************/
var Module = {

  // nsISupports
  QueryInterface: function mod_QI(iid) {
    if (iid.equals(Ci.nsIModule) ||
        iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE;
  },
  
  // nsIModule
  getClassObject: function mod_getClassObject(cm, cid, iid) {
    if (!iid.equals(Ci.nsIFactory))
      throw Cr.NS_ERROR_NOT_IMPLEMENTED;
    
    if (cid.equals(VTI_CLASSID))
      return new GenericFactory(VoteItem);
    else if (cid.equals(VTS_CLASSID))
      return new GenericFactory(VoteService);
          
    throw Cr.NS_ERROR_NO_INTERFACE;
  },

  registerSelf: function mod_registerSelf(cm, file, location, type) {
    var cr = cm.QueryInterface(Ci.nsIComponentRegistrar);  
    
    cr.registerFactoryLocation(VTI_CLASSID, VTI_CLASSNAME, VTI_CONTRACTID,
                               file, location, type);
    cr.registerFactoryLocation(VTS_CLASSID, VTS_CLASSNAME, VTS_CONTRACTID,
                               file, location, type);   
                                
    var catMgr = Components.classes[CAT_CONTRACTID].
                 getService(Ci.nsICategoryManager);
    catMgr.addCategoryEntry(TOPIC_STARTUP_APP, VTS_CLASSNAME, "service," + 
                            VTS_CONTRACTID, true, true);                                                                                         
  },

  unregisterSelf: function mod_unregisterSelf(cm, location, type) {
    var cr = cm.QueryInterface(Ci.nsIComponentRegistrar);
    
    cr.unregisterFactoryLocation(VTI_CLASSID, location);
    cr.unregisterFactoryLocation(VTS_CLASSID, location);
                                
    var catMgr = Components.classes[CAT_CONTRACTID].
                 getService(Ci.nsICategoryManager); 
    catMgr.deleteCategoryEntry(TOPIC_STARTUP_APP, "service," + 
                               VTS_CONTRACTID, true);
  },

  canUnload: function mod_canUnload(cm) { return true; }
};
/*******************************************************************************
 * Entry point used to retrieve the module object.
 ******************************************************************************/
function NSGetModule(cm, file) { return Module; }